ctools - Bug #3156

show_pull_histogram.py broken with matplotlib > 3.1.0

02/05/2020 12:14 PM - Cardenzana Josh

Status: Closed Start date: 02/05/2020
Priority: Normal Due date:

Assigned To: Cardenzana Josh % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1.7.0

Description

This issue only affects source builds. | noticed an issue with show_pull_histogram.py failing the tests. The issue appears to be that
the script uses the "matplotlib.mlab.normpdf” function which was removed in matplotlib v3.1.0 (see here). Running the script with

matplotlib v3.1.3 confirms this method does not exist and throws:

AttributeError: module 'matplotlib.mlab' has no attribute 'normpdf'

| believe issue #3136 is related.

Related issues:
Related to ctools - Bug # 3136: make check fails with test_examples.py

Closed 01/13/2020

History

#1 - 02/05/2020 12:19 PM - Cardenzana Josh
- Related to Bug #3136: make check fails with test_examples.py added

#2 - 02/05/2020 12:29 PM - Cardenzana Josh
- File cspull_test.png added

The documentation suggests using scipy.stats.norm.pdf instead, but that would introduce another dependency.

Instead | propose the simple replacement by the following (which just does the calculation explicitly):

y = np.exp(-0.5*bins*bins) / np.sqrt(2.0*np.pi)

NumPy is already a dependency in the script, but it removes the need for matplotlib.mlab. The results are exactly the same using the suggested

workaround and the explicit formula:
https://matplotlib.org/api/api_changes.html?highlight=histogram#matplotlib-mlab-removals
#3 - 02/05/2020 04:49 PM - Cardenzana Josh
- % Done changed from 0 to 100

I've implemented the above changes here:
Pull information:
e Username: jcardenzana

e repository: ctools
¢ branch: 3156_remove_normpdf

#4 - 02/17/2020 02:07 PM - Knodlseder Jiirgen

- Status changed from New to Pull request

#5 - 02/17/2020 04:55 PM - Knodlseder Jiirgen

- Status changed from Pull request to Closed

Merged into devel.
